/*
 Copyright 2012, S.S. Papadopulos & Assoc. Inc.

    This file is part of GENIE.

    The GENIE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    GENIE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with GENIE.  If not, see<http://www.gnu.org/licenses/>.
*/

// cmuffels, Genie version 1, 2012

#ifndef MANAGEDRUN_H
#define MANAGEDRUN_H

#include <set>
#include <time.h>

#include "modelrun.h"
#include "client.h"

//----------------------------------------------------------------------------
struct cmp_speed
{
  bool operator() (CLIENT *a,CLIENT *b) const
  {
    return a->rating<b->rating;
  }
};

//****************************************************************************
class MANAGED_RUN
//****************************************************************************
{

  public:

    MODEL_RUN *run;

    int status;

    size_t id();
    size_t client_count();
    void set_run(MODEL_RUN *_run);
    void set_status(int _status);
    int add_slave(CLIENT *_slave);
    void remove_slave(CLIENT *_slave);
    void check_client_status();
    void kill_runs(std::multiset<CLIENT*,cmp_speed> *_clients_waiting,
                   std::multiset<CLIENT*,cmp_speed> *_clients_working);

  private:

    std::set<CLIENT*> slaves;

};

#endif /* MANAGEDRUN_H */
